#pragma once

#include "statemch.h"

class Commander : public StateMachine
{
public:

	Commander( GameObject & object ) : StateMachine( object ), m_lastKnownSighting(0, 0, 0), m_radio(true), 
		curRadioMessage(NO_MESSAGE), m_nextLeaderIndex(0), index(0)
		{m_squadList.clear(); m_replacementList.clear(); m_patrolList.clear();}
	~Commander( void ) {}

	inline void RegisterSquad(GameObject* squadLeader)					{m_squadList.push_back(squadLeader);}
	inline void RegisterReplacementSquad(GameObject* squadLeader)		{m_replacementList.push_back(squadLeader);}
	inline void RegisterPatrolSpot(D3DXVECTOR3 patrolSpot)				{m_patrolList.push_back(patrolSpot);}
	objectID FindNearestSquadToAssist(D3DXVECTOR3 areaToAssist, unsigned squadToAssist);
	objectID GenerateNewSquad(unsigned oldSquadIndex);
	void SelectNewLeader(GameObject* oldSquadLeader);
	int PlayerVisible(void);


private:

	virtual bool States( State_Machine_Event event, MSG_Object * msg, int state, int substate );

	//Put member variables or functions here
	float m_heuristicWeight;
	std::vector<GameObject*> m_squadList;	//list of every squad leader
	std::vector<GameObject*> m_replacementList;  //list of replacement squads (by leader)
	std::vector<D3DXVECTOR3> m_patrolList;	//patrol a radius around this location
	D3DXVECTOR3 m_lastKnownSighting;	//last known sighting of the enemy
	bool m_radio;	//if the radio is in working condition
	RadioMessages curRadioMessage;	//message to be send when in radioing state
	unsigned m_nextLeaderIndex;
	int index;
};
