#pragma once

#include "statemch.h"

class Leader : public StateMachine
{
public:

	Leader( GameObject & object ) : StateMachine( object ), m_myIndex(0), m_squadCommander(0), m_lastKnownSighting(0, 0, 0),
		m_radio(true), curRadioMessage(NO_MESSAGE), index(0), m_change(false)				{m_squadList.clear(); m_patrolList.clear();}
	~Leader( void ) {}

	inline void RegisterIndex(unsigned index)						{m_myIndex = index;}
	inline void RegisterSquadCommander(GameObject* squadCommander)	{m_squadCommander = squadCommander;}
	inline void RegisterSquadMember(GameObject* squadMember)		{m_squadList.push_back(squadMember);}
	inline void RegisterPatrolSpot(D3DXVECTOR3 patrolSpot)			{m_patrolList.push_back(patrolSpot);}
	inline void RegisterPatrol(std::vector<D3DXVECTOR3>* patrol)	{m_patrolList.clear(); for(unsigned int i = 0; i < (*patrol).size(); ++i) m_patrolList.push_back((*patrol)[i]);}
	inline void RegisterSquad(std::vector<GameObject*>* squad)		{m_squadList.clear(); for(unsigned int i = 0; i < (*squad).size(); ++i) m_squadList.push_back((*squad)[i]);}
	inline std::vector<D3DXVECTOR3>* GetPatrol(void)				{return &m_patrolList;}
	inline std::vector<GameObject*>* GetSquad(void)					{return &m_squadList;}
	inline objectID GetID(void)										{return m_owner->GetID();}
	int PlayerVisible(void);
	inline int GetSquadSize(void)									{return m_squadList.size();}
	inline void UnregisterSquadMember(void)							{m_squadList.pop_back();}
	inline unsigned GetIndex(void)									{return m_myIndex;}

private:

	virtual bool States( State_Machine_Event event, MSG_Object * msg, int state, int substate );

	//Put member variables or functions here
	float m_heuristicWeight;
	unsigned m_myIndex;
	GameObject* m_squadCommander;	//The Boss, The Head Honcho
	std::vector<GameObject*> m_squadList;	//list of every squad member
	std::vector<D3DXVECTOR3> m_patrolList;	//patrol a radius around this location
	D3DXVECTOR3 m_lastKnownSighting;	//last known sighting of the enemy
	bool m_radio;	//if the radio is in working condition
	RadioMessages curRadioMessage;	//message to be send when in radioing state
	int index;
	bool m_change;
};
