#pragma once

#include "statemch.h"

class Private : public StateMachine
{
public:

	Private( GameObject & object ) : StateMachine( object ), m_squadCommander(0), m_squadLeader(0),
		m_lastKnownSighting(0, 0, 0), m_radio(true), curRadioMessage(NO_MESSAGE), index(0)		
		{m_patrolList.clear();}
	~Private( void ) {}

	inline void RegisterIndex(unsigned index)						{m_myIndex = index;}
	inline void RegisterSquadCommander(GameObject* squadCommander)	{m_squadCommander = squadCommander;}
	inline void RegisterSquadLeader(GameObject* squadLeader)		{m_squadLeader = squadLeader;}
	inline void RegisterPatrolSpot(D3DXVECTOR3 patrolSpot)			{m_patrolList.push_back(patrolSpot);}
	int PlayerVisible(void);

private:

	virtual bool States( State_Machine_Event event, MSG_Object * msg, int state, int substate );

	//Put member variables or functions here
	float m_heuristicWeight;
	unsigned m_myIndex;
	GameObject* m_squadCommander;	//The Boss, The Head Honcho
	GameObject* m_squadLeader;		//The Leader, The Penultimate Honcho
	std::vector<D3DXVECTOR3> m_patrolList;	//patrol a radius around this location
	D3DXVECTOR3 m_lastKnownSighting;	//last known sighting of the enemy
	bool m_radio;	//if the radio is in working condition
	RadioMessages curRadioMessage;	//message to be send when in radioing state
	int index;
};
