#include "agent.h"
#include "terrain.h"
#include <vector>

struct Coord
{
	int x, y;
};

struct Node
{
	float f, g, h;
	Coord pos;
	Node* parent;
};
bool operator==(Coord t, Coord t2);
bool operator!=(Coord t, Coord t2);
bool operator==(Node n1, Node n2);

class AStar
{
public:
	AStar(){};
	AStar(D3DXVECTOR3 start, D3DXVECTOR3 goal, Terrain* t, float heuristicWeight);
	~AStar();
	int Update();
	Node* FindLowestOpen();
	float CalculateH(int x, int y);
	//void UpdateOpenList(int curIndex);
	void AStar::UpdateOpenList(Node* curNode);
	//int CheckIfOnOpen(Coord point);
	Node* AStar::CheckIfOnOpen(Coord point);
	bool CheckIfOnClosed(Coord point);

	Coord start, goal;
	int worldWidth, worldHeight;//width and hieght of the world
	std::list<Node> openList;
	std::list<Node> closedList;
	Terrain *terrain;
	float heuristicWeight;
};