/* Copyright Steve Rabin, 2005. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the copyright text
 * below is included in the resulting source code, for example:
 * "Portions Copyright Steve Rabin, 2005"
 */

#pragma once

#include <assert.h>
#include "dxstdafx.h"

#define ASSERTMSG(a,b) assert(a && b)

#define g_time Time::GetSingleton()
#define g_database Database::GetSingleton()
#define g_msgroute MsgRoute::GetSingleton()
#define g_sound Sound::GetSingleton()
#define g_debuglog DebugLog::GetSingleton()
#define g_debugdrawing DebugDrawing::GetSingleton()
#define g_terrain Terrain::GetSingleton()

struct RadioInformation
{
	RadioInformation(D3DXVECTOR3 loc, unsigned index): location(loc), squadIndex(index) {}
	D3DXVECTOR3 location;
	unsigned squadIndex;
};

enum RadioMessages
{
	NO_MESSAGE,
	STATUS_REQUEST,
	OK,
	NO_RESPONSE,
	INVESTIGATE,
	REPLACE_SQUAD,
	CALL_FOR_REINFORCEMENTS,
	ENEMY_DETECTED,
	ENEMY_SIGHTED,
	ENEMY_DEAD,
	RETURN_TO_SURVEILLANCE,
	LEADER_DEAD
};

enum SOUNDS
{
	SOUND_FOOTSTEP = 0,
	SOUND_STATUS_REQUEST,
	SOUND_OK,
	SOUND_NO_RESPONSE,
	SOUND_INVESTIGATE,
	SOUND_REPLACE_SQUAD,
	SOUND_CALL_FOR_REINFORCEMENTS,
	SOUND_ENEMY_SIGHTED,
	SOUND_ENEMY_DEAD,
	SOUND_RETURN_TO_SURVEILLANCE,
	SOUND_LEADER_DEAD,
	SOUND_YESSIR,
	SOUND_SELF_INVESTIGATE,
	SOUND_SEND_INVESTIGATE,
	SOUND_SELF_ENGAGE,
	SOUND_SEND_ENGAGE,
	SOUND_REQUEST_INVESTIGATE
};

#define INVALID_OBJECT_ID 0
#define SYSTEM_OBJECT_ID 1

typedef unsigned int objectID;
