#pragma once

#ifndef WORLD_H
#define WORLD_H

class Time;
class Database;
class MsgRoute;
class DebugLog;
class DebugDrawing;
class Terrain;
class AnimationManager;
class CMultiAnim;
class CTiny;

#include <vector>
#include "gameobject.h"

class World
{
public:
	World();
	~World();

	void InitializeSingletons( void );
	void Initialize( CMultiAnim *pMA, std::vector< CTiny* > *pv_pChars, CSoundManager *pSM, double dTimeCurrent );
	void PostInitialize();

	void OnLostDevice( void );

	void Update();
	void Animate( double dTimeDelta );
	void AdvanceTimeAndDraw( IDirect3DDevice9* pd3dDevice, D3DXMATRIX* pViewProj, double dTimeDelta, D3DXVECTOR3 *pvEye );
    void RestoreDeviceObjects( LPDIRECT3DDEVICE9 pd3dDevice );

	void InvalidateDeviceObjects( void );

	inline AnimationManager& GetAnimationManager()	{ assert( m_animationManager ); return( *m_animationManager ); }

	void SetGoal(IDirect3DDevice9* pd3dDevice, D3DVIEWPORT9* viewport, D3DXMATRIX* mxView,
					D3DXMATRIX* mxProj, D3DXMATRIX* mxWorld,D3DXVECTOR3* vCamera, D3DXVECTOR3* vTarget);

	Terrain* m_terrain;
protected:

	bool m_initialized;
	Time* m_time;
	Database* m_database;
	MsgRoute* m_msgroute;
	DebugLog* m_debuglog;
	DebugDrawing* m_debugdrawing;

	AnimationManager* m_animationManager;

};

#endif // WORLD_H
